clear      
clc
h1=30e-9;
qe = 1.602176462e-19;
h = 1.054571596e-34;
wp2=0.4*qe/h;
miu=0.3*qe; %chemical of graphene
V1=0.0;   %the applied voltage
V2=0.4;
V=V1;
dV=0.005;
tic                   
c0 = 2.99792458e+8;            %speed of light in vacuum
e0=8.854187817e-12;
miu0=1/(e0*c0^2);
kb = 1.3806503e-23;
T1=900;
h2=390e-9;
tau=1e-13;
e_inf2 = 4;   %ITO optical propertices
tau2=0.1*qe/h;

w01=1;%%InAs optical properties
w02=7e15;
dw=1e12; 
dbeta=1e6;
w=w01:dw:w02;
lamda=2*pi*c0./w;
E=h.*w/qe;
n_inf=1.691;
Egap=0.354;
wc=Egap*qe/h;

% data below was downloaded from the website 'https://refractiveindex.info/?shelf=main&book=InAs&page=Adachi'
% By interpolation, the permittivity at each angular frequency is calculated.
load inas
x=inas(:,1);n=inas(:,2);k=inas(:,3);nw1 = floor((wc-w01)/dw+1);
xx=(2*pi*c0)./x.*1e6;
wcc=(2*pi*c0)./12.5.*1e6;nww1=floor((wcc-w01)/dw+1);
pp1=spline(xx,n,w);
pp2=spline(xx,k,w);
e_InAs=(pp1+1i.*pp2).^2;
n=3.463;k=0.00062436;
e_InAs(1:nww1)=(n+1i*k).^2;  %InAs permittivity

d1=10e-9;
d2=10e-9;
dd=5e-9;
nd=floor((d2-d1)/dd+1);
beta1=1;   %beta range is 0-5e8
beta2=1e9;

nbeta=floor((beta2-beta1)/dbeta+1);
nV=floor((V2-V1)/dV+1);
R1=zeros(nV,1);
R2=R1;
R=R1;
xi=zeros(length(w),nbeta);
xi_far=xi;
xi_near=xi;
F=xi;
Ee=xi;
Ep=xi;
Q_xi=xi;
Q_xi_near=xi;
Q_near=xi;
Q_xi_far=xi;
Q_far=xi;

Q=xi;
F3=R1;Ee3=R1;Ep3=R1;J1=R1;J2=R1;P1=R1;G=R1;T2=R1;P2=R1;G2=R1;

for s1=1:nV
    V=V1+(s1-1)*dV;
    %nonradiative recombination rate   
    T2=300;
    T=T2;
    ni=6.06e20;
    n1=2e16*1e6;
    p1=ni^2/n1*exp((qe*V/(kb*T)));
    tauR=100*1e-9;
    Cn=2.26*10^(-27)*10^(-12);
    Cp=Cn;
    R1(s1)=(Cn*n1+Cp*p1)*(n1*p1-ni^2)*h2;
    R2(s1)=(n1*p1-ni^2)*h2/(tauR*(n1+p1+2*ni));
    R(s1)=R1(s1)+R2(s1);

    for jj=1:nd
        d=d1+(jj-1)*dd;
        for ii=1:length(w)
            w1=w(ii);
            H1=h*w1/(exp(h*w1/(kb*T1))-1);
            H2=h*w1/(exp(h*w1/(kb*T2))-1);
            H2V=h*w1/(exp((h*w1-qe*V)/(kb*T2))-1);
            sigma=qe^2*miu*tau/(pi*h^2*(1-1i*w1*tau)); % graphene electric conductivity 
            e_ITO=e_inf2*(1-wp2^2/(w1^2+1i*w1*tau2));
            sigma1=0;% sigma1=sigma means that grapnene modulates on the emitter,and sigma1=0 means that graphene doesn't modulating on the emitter
            sigma2=0;% sigma2=simga means that graphene modulates on the emitter,and sigma1=0 means that graphene doesn't modulating on the receiver              
            e11=e_ITO;
            e12=e_ITO;
            e21=e_InAs(ii);  
            e22=e_InAs(ii);
            %%
            %1 means perpendicular; 2 means  parallel
            k0=w1/c0;
            for j=1:nbeta
                beta=beta1+(j-1)*dbeta;     %1 means perpendicular; 2 means  parallel
                kz1=(k0^2-beta^2)^0.5;
                kz2p1=(e11*k0^2-(e11/e12)*beta^2)^0.5;  

                kz2p2=(e21*k0^2-(e21/e22)*beta^2)^0.5;  
                kz2s1=(e11*k0^2-beta^2)^0.5;
                kz2s2=(e21*k0^2-beta^2)^0.5;
                kz3=kz1;

                %%
                %p polarization coefficient 1,2,3,represnet air
                %% material 1
                r12p1=(kz1*e11-kz2p1+kz1*kz2p1*sigma1/(e0*w1))/(kz1*e11+kz2p1+kz1*kz2p1*sigma1/(e0*w1));
                r21p1=(kz2p1-kz1*e11+kz1*kz2p1*sigma1/(e0*w1))/(kz2p1+kz1*e11+kz1*kz2p1*sigma1/(e0*w1));
                r23p1=(kz2p1-kz3*e11)/(kz2p1+kz3*e11);
                r1p=(r12p1+(1-r12p1-r21p1)*r23p1*exp(1i*2*kz2p1*h1))/(1-r21p1*r23p1*exp(1i*2*kz2p1*h1));
                %% material 2
                r12p2=(kz1*e21-kz2p2+kz1*kz2p2*sigma2/(e0*w1))/(kz1*e21+kz2p2+kz1*kz2p2*sigma2/(e0*w1));
                r21p2=(kz2p2-kz1*e21+kz1*kz2p2*sigma2/(e0*w1))/(kz2p2+kz1*e21+kz1*kz2p2*sigma2/(e0*w1));
                r23p2=(kz2p2-kz3*e21)/(kz2p2+kz3*e21);
                r2p=(r12p2+(1-r12p2-r21p2)*r23p2*exp(1i*2*kz2p2*h2))/(1-r21p2*r23p2*exp(1i*2*kz2p2*h2));

                %%
                %s polarization  reflection coefficient
                %% material 1
                r12s1=(kz1-sigma1*w1*miu0^2-kz2s1)/(kz1+sigma1*w1*miu0^2+kz2s1);
                r21s1=(kz2s1-sigma1*w1*miu0^2-kz1)/(kz2s1+sigma1*w1*miu0^2+kz1);
                r23s1=(kz2s1-kz3)/(kz2s1+kz3);
                r1s=(r12s1+(1+r12s1+r21s1)*r23s1*exp(1i*2*kz2s1*h1))/(1-r21s1*r23s1*exp(1i*2*kz2s1*h1));

                %% material 2
                r12s2=(kz1-sigma2*w1*miu0^2-kz2s2)/(kz1+sigma2*w1*miu0^2+kz2s2);
                r21s2=(kz2s2-sigma2*w1*miu0^2-kz1)/(kz2s2+sigma2*w1*miu0^2+kz1);
                r23s2=(kz2s2-kz3)/(kz2s2+kz3);
                r2s=(r12s2+(1+r12s2+r21s2)*r23s2*exp(1i*2*kz2s2*h2))/(1-r21s2*r23s2*exp(1i*2*kz2s2*h2));

                %%
                % energy transmission coefficient
                if (beta<=k0)    % propagating waves 
                    xi_p=(1-(abs(r1p))^2)*(1-(abs(r2p))^2)/((abs(1-(r1p)*(r2p)*exp(1i*2*kz1*d)))^2);
                    xi_s=(1-(abs(r1s))^2)*(1-(abs(r2s))^2)/((abs(1-(r1s)*(r2s)*exp(1i*2*kz1*d)))^2);
                    xi(ii,j)=xi_p+xi_s;% 
                    xi_far(ii,j)=xi(ii,j);
                    xi_near(ii,j)=0;

                else     %evanescent waves
                    xi_p=4*imag(r1p)*imag(r2p)*exp(-2*imag(kz1)*d)/((abs(1-(r1p)*(r2p)*exp(1i*2*kz1*d)))^2);
                    xi_s=4*imag(r1s)*imag(r2s)*exp(-2*imag(kz1)*d)/((abs(1-(r1s)*(r2s)*exp(1i*2*kz1*d)))^2);
                    xi(ii,j)=xi_p+xi_s; %energy transmission coefficient
                    xi_far(ii,j)=0;
                    xi_near(ii,j)=xi(ii,j);
                end

                %%
                % heat flux spectrum
                Q_xi(ii,j)=xi(ii,j)*beta*dbeta;
                Q(ii,j)=(1/(4*pi^2))*(H1-H2)*Q_xi(ii,j);
                if (w1>=wc)
                    F(ii,j)=(1/(4*pi^2*h*w1))*(H1-H2V)*Q_xi(ii,j);
                    Ee(ii,j)=(1/(4*pi^2))*(H1-H2V)*Q_xi(ii,j);
                    Ep(ii,j)=0;
                else
                    F(ii,j)=0;
                    Ee(ii,j)=0;
                    Ep(ii,j)=(1/(4*pi^2))*(H1-H2)*Q_xi(ii,j);
                end
                Q_xi_near(ii,j)=xi_near(ii,j)*beta*dbeta;
                Q_near(ii,j)=(1/(4*pi^2))*(H1-H2)*Q_xi_near(ii,j);
                
                Q_xi_far(ii,j)=xi_far(ii,j)*beta*dbeta;
                Q_far(ii,j)=(1/(4*pi^2))*(H1-H2)*Q_xi_far(ii,j);
            end
        end
        F1=nansum(F);   F2=F1*dw;   F3(s1)=nansum(F2);   %F12(0)-F21(V)
        Ee1=nansum(Ee); Ee2=Ee1*dw; Ee3(s1)=nansum(Ee2); %Ee (Ee3)
        Ep1=nansum(Ep); Ep2=Ep1*dw; Ep3(s1)=nansum(Ep2); %Ep (Ep3)
        

        J1(s1)=qe*(F3(s1)-R(s1)); %nonradiative recombination included
        P1(s1)=J1(s1)*V;
        G(s1)=P1(s1)/(Ee3(s1)+Ep3(s1));

        J2(s1)=qe*(F3(s1));%nonradiative recombination excluded
        P2(s1)=J2(s1)*V;
        G2(s1)=P2(s1)/(Ee3(s1)+Ep3(s1));

        % plot(w,Q1)
        Q1=nansum(Q);
        q=Q1*dw;
        q1=nansum(q); 
        spectral_heat=nansum(Q,2);

    end
end

toc
save('F3','J1','J2','P1','P2','G','G2')